package de.ddd.android;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;

import android.app.Activity;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.Bundle;
import android.os.Environment;
import android.text.format.Time;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.TextView;

public class UVCCaptureAppActivity extends Activity {
	
	private final static int STAT_INTERVAL = 1000;
	private long statusIntervalTimer = 0l;
	private long lastStatusStore = 0l;
	private int fpsCounter = 0;
	
    private Camera _camera;
	private ImageView _imageView;
	private TextView _textView;
	private int _counter;
	private int _framesize;
	private ExtAudioRecorder _recorder;
	private Process rootShell;
	
	private String alsacmd = "/system/bin/alsa_aplay -D hw:1,0 -C -f S16_LE -c 1 -r 48000 -d 30 /mnt/sdcard/Movies/apprecorded.wav\n";
	private String chmodcommand = "chmod 666 /dev/snd/*\n";
    @Override
    public void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        try {
        	rootShell = Runtime.getRuntime().exec("su");
        	
        	String insmod_hwdep = "insmod /system/lib/modules/snd-hwdep.ko\n";
        	rootShell.getOutputStream().write(insmod_hwdep.getBytes(), 0, insmod_hwdep.length());

        	String insmod_rawmidi= "insmod /system/lib/modules/snd-rawmidi.ko\n";
        	rootShell.getOutputStream().write(insmod_rawmidi.getBytes(), 0, insmod_rawmidi.length());
        	
        	String insmod_usbmidi= "insmod /system/lib/modules/snd-usbmidi-lib.ko\n";
        	rootShell.getOutputStream().write(insmod_usbmidi.getBytes(), 0, insmod_usbmidi.length());
        	
        	String insmod_usbaudio= "insmod /system/lib/modules/snd-usb-audio.ko\n";
        	rootShell.getOutputStream().write(insmod_usbaudio.getBytes(), 0, insmod_usbaudio.length());
        	
			rootShell.getOutputStream().write(chmodcommand.getBytes(), 0, chmodcommand.length());
		
        } catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		} 

       
        setContentView(R.layout.main);
        
        _imageView = (ImageView) findViewById(R.id.imageCanvas);
        _textView = (TextView) findViewById(R.id.textView1);
        
        _camera = new Camera(0, true);
        
        _counter = 0;
        
        final File externalDir = Environment.getExternalStoragePublicDirectory(Environment.DIRECTORY_MOVIES);
        
        try {
			_camera.init(1280, 720);
		} catch (IOException e) {
			e.printStackTrace();
		}

		_camera.setPreviewCallback(new Camera.PreviewCallback() {
			@Override
			public void onPreviewFrame(byte[] data, Camera camera, int framesize) {
				// ----------------------
				// Speichern im oeffentlichen App-Ordner
				// ----------------------
				
				try {
					//File f = new File(externalDir, "movie2.jpg");//String.format("frame_%05d.jpg",_counter));
					//OutputStream os;
					if(_counter == 0)
					{
						//os = new FileOutputStream(f);
//						new Thread(new Runnable() {
//						    public void run() {
//								try {
//									rootShell.getOutputStream().write(alsacmd.getBytes(), 0, alsacmd.length());
//								} catch (IOException e) {
//									// TODO Auto-generated catch block
//									e.printStackTrace();
//								}
//						    }
//						}).start();
					}
					else
						//os = new FileOutputStream(f, true);
					if(_counter >= 125){
						//os.write(data, 0, framesize);
					}
					_framesize = framesize;

					//os.close();
				} catch (Exception e) {
					e.printStackTrace();
				}
				if(_counter >= 50*30){
					_camera.stopPreview();
					//System.exit(0);
				}
				_counter++;
			}
		});
		
		
		Button startVideo = (Button) findViewById(R.id.videoCaptureStartButton);
		startVideo.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				_camera.startPreview();
				

			}
		});

		Button stopVideo = (Button) findViewById(R.id.videoCaptureStopButton);
		stopVideo.setOnClickListener(new OnClickListener() {
			@Override
			public void onClick(View v) {
				_camera.stopPreview();
			}
		});
		 		
		
//		
//		_recorder = ExtAudioRecorder.getInstanse(ExtAudioRecorder.RECORDING_UNCOMPRESSED);
//		_recorder.setOutputFile(new File(externalDir, "/audio.wav").getAbsolutePath());
//		
//		
//		Button startButton = (Button) findViewById(R.id.videoCaptureStartButton);
//		startButton.setOnClickListener(new OnClickListener() {
//			@Override
//			public void onClick(View v) {
//				_recorder.prepare();
//				_recorder.start();
//			}
//		});
//		
//		
//		
//		Button stopButton = (Button) findViewById(R.id.videoCaptureStopButton);
//		stopButton.setOnClickListener(new OnClickListener() {
//			@Override
//			public void onClick(View v) {
//				_recorder.stop();
//				_recorder.release();
//			}
//		});
//		
		//_camera.startPreview();

    }
    
    private static final int IO_BUFFER_SIZE = 4 * 1024;  
    
    private static void copyStream(InputStream in, OutputStream out) throws IOException {  
    	byte[] b = new byte[IO_BUFFER_SIZE];  
    	int read;  
    	while ((read = in.read(b)) != -1) {  
    		out.write(b, 0, read);  
    	}  
    }  
}